/*
 *  
 *  Copyright (c) by Shuu Yamaguchi <shuu@wonder.ne.jp>
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>

#include	"usbmgr.h"

/*
 * create mod_link
 */
struct node *
create_modlink(struct node **base,struct node *mod)
{
	struct node *mlink;

	mlink = create_node();
	if (mlink == NULL)
		return NULL;
	SET_TYPE_MODLINK(mlink);
	link_node(base,mlink);
	mlink->data = mod;

	return mlink;
}

/*
 * add mod_link
 * should use #define
 */
void
add_modlink(struct node *link, struct node *mlink)
{
	add_node(link,mlink);
}

/*
 * search module in module link
 * [return]
 * 	modlink
 */
struct node *
find_string_modlink(struct node *start,char *name)
{
	struct node *mlink;

	if (!NODE_IS_MODLINK(*start))
		return NULL;
	for (mlink = start; ;mlink = mlink->next) {
		if (strcmp((char *)mlink->data->data,name) == 0)
			return mlink;
		if (mlink->next == start)
			break;
	}
	return NULL;
}

#ifdef	DEBUG
void
dump_modlink(struct node *start)
{
	struct node *mlink;
	for (mlink = start; ;mlink = mlink->next) {
		syslog(LOG_DEBUG,"modlink:%p <- %p(module:\"%s\") -> %p",
			mlink->prev,mlink,mlink->data->data,mlink->next);
		if (mlink->next == start)
			break;
	}
}
#endif	/* DEBUG */
