/*
 *  
 *  Copyright (c) by Shuu Yamaguchi <shuu@wonder.ne.jp>
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>

#include	"usbmgr.h"

/*
 * points to link in first usbmodule
 */
static struct node *module_ring = NULL;

/*
 * create module
 */
struct node *
create_module(char *name)
{
	struct node *mod;

	mod = (struct node *)malloc(sizeof(struct node) + strlen(name) + 1);
	if (mod == NULL)
		return NULL;
	INIT_NODE(mod);
	SET_TYPE_MODULE(mod);
	(char *)mod->data = (char *)(&(mod->data)+1);
	strcpy((char *)mod->data,name);
	link_node(&module_ring,mod);

	return mod;
}

#ifdef	DEBUG
void
dump_moduletree_ring(void)
{
	struct node *np;

	for(np = module_ring; ;np = np->next){
		syslog(LOG_DEBUG,"module:0x%p <-  0x%p(0x%x:\"%s\") -> 0x%p\n",
			np->prev,np,np->type,np->data,np->next);
		if (np->next == module_ring)
			break;
	}
}
#endif

/*
 * search module in module_ring
 * should use #define
 */
struct node *
find_string_module(char *name)
{
	return find_string_node(module_ring,name);
}

