/*
 *  
 *  Copyright (c) by Shuu Yamaguchi <shuu@wonder.ne.jp>
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */
#include	<stdio.h>

#include	"node.h"

/*
 * create node
 */
struct node *
create_node(void)
{
	struct node *np;

	np = (struct node *)malloc(sizeof(struct node));
	if (np == NULL)
		return NULL;
	INIT_NODE(np);

	return np;
}

/*
 * delete note
 */
void
delete_node(struct node *np)
{
	free(np);
}

/*
 * link node
 */
void
link_node(struct node **linkp,struct node *np)
{
	if (*linkp == NULL)
		*linkp = np;
	else
		add_node(*linkp,np);
}

/*
 * add node
 */
void
add_node(struct node *link,struct node *np)
{
	np->next = link;
	np->prev = link->prev;
	link->prev->next = np;
	link->prev = np;
}

/*
 * find data in node
 */
struct node *
find_string_node(struct node *start,char *name)
{
	struct node *np;

	if (start == NULL || !NODE_IS_MODULE(*start))
		return NULL;
	for (np = start; ;np = np->next) {
		if (strcmp((char *)np->data,name) == 0)
			return np;
		if (np->next == start)
			break;
	}
	return NULL;
}
