/*
 *  
 *  Copyright (c) by Shuu Yamaguchi <shuu@wonder.ne.jp>
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */
#ifndef	__USBMGR_NODE_H
#define	__USBMGR_NODE_H

struct node {
	struct node *prev;
	struct node *next;
	int type;
	struct node *data;
};

#define USB_TYPE_NONE		(0)
#define USB_TYPE_DEVICE		(1)
#define USB_TYPE_MODULE		(USB_TYPE_DEVICE << 1)
#define USB_TYPE_MODLINK	(USB_TYPE_MODULE << 1)
#define USB_TYPE_CONFIG		(USB_TYPE_MODLINK << 1)
#define USB_TYPE_VENDOR		(USB_TYPE_CONFIG << 1)
#define USB_TYPE_CLASS		(USB_TYPE_VENDOR << 1)

#define	DEFINE_NODE(np)	struct node * (np) = { NULL,NULL,USB_TYPE_NONE,NULL };
#define	INIT_NODE(np)	(np)->prev = (np)->next = (np);(np)->data = NULL;(np)->type = USB_TYPE_NONE

#define	NODE_IS_DEVICE(np)	((np).type == USB_TYPE_DEVICE)
#define	NODE_IS_MODULE(np)	((np).type == USB_TYPE_MODULE)
#define	NODE_IS_MODLINK(np)	((np).type == USB_TYPE_MODLINK)
#define	NODE_IS_CONFIG(np)	((np).type == USB_TYPE_CONFIG)
#define	NODE_IS_VENDOR(np)	((np).type == USB_TYPE_VENDOR)
#define	NODE_IS_CLASS(np)	((np).type == USB_TYPE_CLASS)

#define	SET_TYPE_DEVICE(np)	((np)->type = USB_TYPE_DEVICE)
#define	SET_TYPE_MODULE(np)	((np)->type = USB_TYPE_MODULE)
#define	SET_TYPE_MODLINK(np)	((np)->type = USB_TYPE_MODLINK)
#define	SET_TYPE_CONFIG(np)	((np)->type = USB_TYPE_CONFIG)
#define	SET_TYPE_VENDOR(np)	((np)->type = USB_TYPE_VENDOR)
#define	SET_TYPE_CLASS(np)	((np)->type = USB_TYPE_CLASS)

extern struct node * create_node(void);
extern void link_node(struct node **,struct node *);
extern void add_node(struct node *,struct node *);
extern struct node * find_string_node(struct node *,char *);

#endif	/* __USBMGR_NODE_H */

