/*
 *  
 *  Copyright (c) by Shuu Yamaguchi <shuu@wonder.ne.jp>
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */
#ifndef	__USBMGR_H
#define	__USBMGR_H

#include	<sys/types.h>
#include	<syslog.h>

#include	"node.h"

struct config_id {
	__uint16_t	vendor;			/* vendor ID */
	__uint16_t	product;		/* product ID */
	__uint8_t	class;			/* class number */
	__uint8_t	subclass;		/* subclass number */
	__uint8_t	protocol;		/* protocol number */
	__uint8_t	type;			/* available ID type */
};

struct config {
	struct node link;
	struct config_id id;
	char *script;				/* starting executable file */
};

struct usbdevice {
	struct node link;	/* link to "link" in other usbdevice */
	struct node *pdev;	/* points to parent device(hub) */
	struct config conf;
};

#define	USB_DIR_ETC		"/etc/usb"
#define	USB_PROCDIR		"/proc/bus/usb"
#define	USB_FILE_CONF		"usbmgr.conf"
#define	USB_FILE_PID		"usbmgr.pid"
#define	USB_DIR_PID		"/var/run"
#define	USB_NOMODULE		"none"
#define	SLEEP_TIME		1

extern char *host_module;
extern int debug;

extern struct usbdevice * find_device_all(struct usbdevice);
extern struct usbdevice * create_device(struct node *);
extern int get_loader(void);
extern int module_load(char *);
extern struct config * find_config_all(struct config);
extern struct node * find_string_device_all(char *);
extern void init_config(struct config *);
extern struct config * create_config(void);
extern struct node * create_modlink(struct node **,struct node *);
extern struct node * find_string_modlink(struct node *,char *);
extern struct node * create_module(char *);
extern struct node * find_string_module(char *);
extern void execute_script(char *);

#endif	/* __USBMGR_H */
